<template>
  <vab-dialog v-model="dialogFormVisible" append-to-body :title="title" width="500px" @close="close">
    <el-form ref="formRef" label-width="80px" :model="form" :rules="rules">
      <el-form-item label="参数1" prop="param1">
        <el-input v-model="form.param1" placeholder="请输入参数1" />
      </el-form-item>
      <el-form-item label="参数2" prop="param2">
        <el-input v-model="form.param2" placeholder="请输入参数2" />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-radio-group v-model="form.status">
          <el-radio v-for="dict in sys_normal_disable" :key="dict.value" :value="dict.value">{{ dict.label }}</el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button type="primary" @click="save">确 定</el-button>
      <el-button @click="cancel">取 消</el-button>
    </template>
  </vab-dialog>
</template>

<script lang="ts" setup>
import type { FormInstance } from 'element-plus'
import { doAdd, doEdit, getPost } from '/@/api/postManagement'

defineOptions({
  name: 'XxxEdit',
})

const { proxy } = getCurrentInstance() as any
const { sys_normal_disable } = proxy.useDict('sys_normal_disable')

const emit = defineEmits(['fetch-data'])

const formRef = ref<FormInstance>()
const form = ref<any>({
  xxxId: undefined,
  param1: undefined,
  param2: undefined,
  status: '0',
})
const rules = reactive<any>({
  param1: [{ required: true, message: '参数1不能为空', trigger: 'blur' }],
  param2: [{ required: true, message: '参数2不能为空', trigger: 'blur' }],
})
const title = ref<string>('')
const dialogFormVisible = ref<boolean>(false)

const showEdit = (row?: any) => {
  reset()
  if (row && row.xxxId) {
    title.value = '编辑'
    getPost(row.xxxId).then((response: any) => {
      form.value = response.data
      dialogFormVisible.value = true
    })
  } else {
    title.value = '添加'
    dialogFormVisible.value = true
  }
}

/** 表单重置 */
function reset() {
  form.value = {
    xxxId: undefined,
    param1: undefined,
    param2: undefined,
    status: '0',
  }
  proxy.resetForm('formRef')
}

const close = () => {
  formRef.value?.clearValidate()
  formRef.value?.resetFields()
  emit('fetch-data')
}

const cancel = () => {
  close()
  dialogFormVisible.value = false
}

const save = () => {
  formRef.value?.validate(async (valid: any) => {
    if (valid) {
      if (form.value.xxxId) {
        await doEdit(form.value)
        await $baseMessage('修改成功', 'success', 'hey')
      } else {
        await doAdd(form.value)
        await $baseMessage('添加成功', 'success', 'hey')
      }
      cancel()
    }
  })
}

defineExpose({
  showEdit,
})
</script>

<style lang="scss" scoped>
:deep() {
  .el-select {
    width: 100%;
  }
}
</style>
